/**
 * @class MatchError
 * Errors thrown by the {@link Match} class
 */
export declare class MatchError extends Error {
    constructor(m: string);
}
/**
 * Error thrown when a match is explicitly destroyed (by the user generally) by calling {@link Match.destroy}
 */
export declare class MatchDestroyedError extends MatchError {
    constructor(m: string);
}
/**
 * Errors related to replay files
 */
export declare class MatchReplayFileError extends MatchError {
    constructor(m: string);
}
/**
 * Errors related to log files
 */
export declare class MatchErrorLogFileError extends MatchError {
    constructor(m: string);
}
